=begin
Copyright 2012 (c) TIG.
Permission to use, copy, modify, and distribute this software for 
any purpose and without fee is hereby granted, provided that the above
copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###
TIG-weldall.rb
###
Welds ALL edges in a model [including any nested inside groups/component-
definitions] into curves.
Note that disconnected edges or branching edges will all become curves, but 
some might be one segemnt long where a vertec has more than two edges...
Note: it requires script TIG-weld.rb loading too...
Usage: in the Ruby Console type, TIG.weldall +<enter>
It is one step undobale.
###
Donations:
By PayPal.com to info @ revitrev.org
###
Version:
1.0 20120305 First issue.
###
=end
###
module TIG
 def self.weldall()
  require 'TIG-weld.rb'
  se=Sketchup::Edge
  all=[]
  m=Sketchup.active_model
  all << m.entities.to_a.find_all{|e|e.class==se}
  m.definitions.each{|d|
    next if d.image?
    all << d.entities.to_a.find_all{|e|e.class==se}
  }
  s=m.selection
  m.start_operation('weldall')
  all.each{|a|
    a.each{|e|e.explode_curve if e.curve}
    done=false
    until done
      al=a.length
      s.clear
      s.add(a)
      TIG.weld(true)
      a.dup.each{|e|
        a.delete(e) unless e.valid?
        next unless e.valid? and e.curve
        a.delete(e)
      }
      done=true if al==a.length
    end
  }
  s.clear
  m.commit_operation
  UI.beep
 end
end
###